package indexjob;

import java.io.*;
import java.lang.Process;
import java.lang.Runtime;

/*
TODO: change allocator to have methods for scheduling, indexing, searching and crawling jobs.

*/
public class indexallocator{

    public static void main(String[] args)throws Exception{

        if (args.length != 1) {
            System.out.println("Usage:java indexallocator CORPUSNAME (on SRB)");
        }
	
	//String corpus = args[0];
	String output = args[0];

        BufferedReader serverFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/indexjob/servers")));
        int totservers = Integer.parseInt(serverFile.readLine());
        String [] servers = new String[totservers];
        for(int i =0; i < totservers; i++){
            servers[i] = serverFile.readLine();
        }
        serverFile.close();

	PrintWriter submitfile = new PrintWriter (new BufferedWriter (new FileWriter ("indexjob.submit", false))); //false for do not append
	String description = "Universe = java\nExecutable = /home/nnakasho/apps/GriSAD/indexjob/indexjob.class\nLog = indexjob.log.$(Cluster)\nOutput = indexjob.out.$(Cluster).$(Process)\nError ="+ "indexjob.error.$(Cluster)\nRequirements = machine =!= \"simba.cs.uct.ac.za\" \nShould_transfer_files = YES\nWhenToTransferOutput = ON_EXIT\ntransfer_input_files = /home/nnakasho/.srb/.MdasEnv,/home/nnakasho/.srb/.MdasAuth \njar_files = "+"/home/nnakasho/apps/lib/jargon_v1.4.20.jar,/home/nnakasho/apps/lib/lucene-core-2.1.0.jar,"+"/home/nnakasho/apps/GriSAD/indexjob/requiredfiles/requiredfiles.jar,/home/nnakasho/apps/lib/jargon_v1.4.20.jar,/home/nnakasho/apps/lib/fontbox.jar,/home/nnakasho/apps/lib/PDFBox.jar,/home/nnakasho/apps/lib/tm-extractors.jar\nnotification = never\n";

	// Different arguments for each job, i.e. a single directory is allocated for one indexing job
        int server =0;
	for(int i =1; i <= totservers; i++){
            String arg = "Arguments = indexjob "+ output + " ";
            arg+=Integer.toString(i);
            arg+="\nRequirements = machine == \""+servers[server++]+"\"";
            description+= (arg+"\nQueue\n\n");
            if(server>=totservers)
                server=0;
	}
	submitfile.println (description);
	submitfile.close();

        String cmd = "condor_submit indexjob.submit";
        Process p = Runtime.getRuntime().exec(cmd); //run the splitter program*/

   }
}