package queryjob;

import java.io.*;
import java.lang.Process;
import java.lang.Runtime;
import java.net.*;
import java.util.Date;

public class CODQueryallocator{
    //allocate an number of queries
    public String allocate(String[] queries, String[] CODclaims, int QueryID) throws Exception{
        ServerSocket server = new ServerSocket(0);
        int port = server.getLocalPort();
        String filename = "/home/nnakasho/apps/GriSAD/queryjob/cod.submit";//+new Integer(port).toString();
        PrintWriter submitfile = new PrintWriter (new BufferedWriter (new FileWriter (filename, false))); 

	String description = "Cmd = \"java -cp $AXISCLASSPATH:$CLASSPATH \"\nIwd = \"/home/nnakasho/apps/GriSAD/queryjob\"\nOut = \"cod.out\"\nErr = \"/home/nnakasho/apps/GriSAD/queryjob/cod.error\"\nowner = \"nnakasho\"\nArgs = \"queryjob " + queries[0] + " " +QueryID+ " "+ CODclaims.length+ " "+ port+"\"\nJobUniverse = 10\nJarFiles = \"/home/nnakasho/apps/lib/jargon_v1.4.20.jar /home/nnakasho/apps/lib/lucene-core-2.1.0.jar requiredfiles/requiredfiles.jar /home/nnakasho/apps/axis-1_4/lib/axis.jar /home/nnakasho/apps/axis-1_4/lib/wsdl4j-1.5.1.jar /home/nnakasho/apps/axis-1_4/lib/commons-discovery-0.2.jar /home/nnakasho/apps/axis-1_4/lib/jaxrpc.jar /home/nnakasho/apps/axis-1_4/lib/commons-logging-1.0.4.jar /home/nnakasho/apps/axis-1_4/lib/saaj.jar /home/nnakasho/apps/axis-1_4/lib/xerces.jar /home/nnakasho/apps/axis-1_4/lib/log4j-1.2.8.jar /home/nnakasho/apps/axis-1_4/lib/xercesImpl.jar\"";

          String ut = "";
        /*try{
            for(int i =0; i < queries.length; i++){
                String arg = "Arguments = queryjob uct";//+ queries[i] + " ";
                description+= (arg+"\nQueue\n");
            }
        }
        catch(Exception e){
            return "Error by args\n";
        }
        description+="Requirements = machine == \"machine2.cluster.aim\"\nQueue\n\n";*/
        submitfile.println (description);
        submitfile.close ();

        for(int j =0; j< CODclaims.length;j++){
            String cmd = "/home/condor/bin/condor_cod activate -id " +CODclaims[j]+ " -jobad "+filename;
            Process p = Runtime.getRuntime().exec(cmd); //run the splitter program*/
            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            String line = null;
            while ((line = in.readLine()) != null){
            //ut+=line;
            }
                
    
            BufferedReader in2 = new BufferedReader( new InputStreamReader(p.getErrorStream()));
           // ut+="\n\nRandom: ";
           // ut+="\n";
            while ((line = in.readLine()) != null) {
                
            }
               // ut+=line;
         }
        
        ut+="\n";

        //listen, get results, and return them        
        
       
        Date start = new Date();
        Socket client = server.accept(); //wait for results
        BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
        String line = null;
        Date end = new Date(); 
        ut+= "\tTotal time waiting for results from worker nodes: " +(new Long(end.getTime() - start.getTime())).toString() + " milliseconds\n";
        ut+="\t++Results++\n";
        while((line = in.readLine()) !=null){
            ut+="\t"+line+"\n";
        }

        in.close();
        server.close();
        client.close();
        
        //wait for response here, otherwise this will return to client before delivering ansewer
        //call the service Query service, and merge results
        //have a blocking call here waiting for results (); i.e. using call back then return these results to client
        // ** the new thing is to send results via sockets, when the results are available they are sent to the receiving client, 
        // when we have a browser based client these results will be sent to the browser by using Servlets, 
        return ut;
    }

}
