package queryjob;

import java.io.*;
import java.lang.Process;
import java.lang.Runtime;
public class Starter{
    
    // start query programs on the known query servers
    public static void main(String [] args)throws Exception
    {
        BufferedReader serverFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/queryjob/servers")));
        int totservers = Integer.parseInt(serverFile.readLine());
        String [] servers = new String[totservers];
        for(int i =0; i < totservers; i++){
            servers[i] = serverFile.readLine();
        }
        serverFile.close();
        //writeMdasEnv("machine1.cluster.aim");

	PrintWriter submitfile = new PrintWriter (new BufferedWriter (new FileWriter ("queryjob.submit", false))); //false for do not append
	String description = "Universe = java\nExecutable = /home/nnakasho/apps/GriSAD/queryjob/queryjob.class\nLog = queryjob.log.$(Cluster)\nOutput = queryjob.out.$(Cluster).$(Process)\nError ="+ "queryjob.error.$(Cluster)\nRequirements = machine =!= \"simba.cs.uct.ac.za\" \nShould_transfer_files = YES\nWhenToTransferOutput = ON_EXIT\ntransfer_input_files = /home/nnakasho/.srb/.MdasEnv,/home/nnakasho/.srb/.MdasAuth \njar_files = "+"/home/nnakasho/apps/lib/jargon_v1.4.20.jar,/home/nnakasho/apps/lib/lucene-core-2.1.0.jar,"+"/home/nnakasho/apps/GriSAD/queryjob/requiredfiles/requiredfiles.jar /home/nnakasho/apps/axis-1_4/lib/axis.jar /home/nnakasho/apps/axis-1_4/lib/wsdl4j-1.5.1.jar /home/nnakasho/apps/axis-1_4/lib/commons-discovery-0.2.jar /home/nnakasho/apps/axis-1_4/lib/jaxrpc.jar /home/nnakasho/apps/axis-1_4/lib/commons-logging-1.0.4.jar /home/nnakasho/apps/axis-1_4/lib/saaj.jar /home/nnakasho/apps/axis-1_4/lib/log4j-1.2.8.jar\nnotification = never\nowner = \"nnakasho\"\n";
     
	for(int i =0; i <servers.length; i++){
            if(!servers[i].equals("dizzy.lcc.uct.ac.za")){
                String arg = "Arguments = queryjob";
                arg+="\nRequirements = machine == \""+servers[i]+"\"";
                description+= (arg+"\nQueue\n\n");
            }
	}
	submitfile.println (description);
	submitfile.close();

        String cmd = "condor_submit queryjob.submit";
        Process p = Runtime.getRuntime().exec(cmd); //run the splitter program*/

    }
    public static void writeMdasEnv(String host)throws Exception{
        String content = "mdasCollectionName '/hpc/home/srbAdmin.ucthpc'\nmdasCollectionHome '/hpc/home/srbAdmin.ucthpc'\nmdasDomainName 'ucthpc'\nmdasDomainHome 'ucthpc'\nsrbUser 'srbAdmin'\nsrbHost '" +host + "'\n#srbPort '5544'\ndefaultResource 'machine1'\nAUTH_SCHEME 'ENCRYPT1'";
        PrintWriter out2 = new PrintWriter(new BufferedWriter(new FileWriter("/home/nnakasho/.srb/.MdasEnv", false)));
        out2.println(content);
        out2.close();
    }

}
