import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.Term;
import org.apache.lucene.index.TermEnum;
import org.apache.lucene.store.SRBDirectory;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;

import java.util.StringTokenizer;
import java.lang.Process;
import java.lang.Runtime;
import java.io.*;
import java.util.Vector;
import java.util.Date;

public class MergeIndices{
    public static void main(String [] args)throws Exception{
        System.out.println("merging indices");
        String localhost = java.net.InetAddress.getLocalHost().getHostName();
        String localvault = new StringTokenizer(localhost, ".").nextToken();

        //String localvault = "indices";

        BufferedReader in,in2;
        String host,cmd,line,dir, name;
        Unzip unzip = new Unzip();
        StringTokenizer st;
        Process p;
        cmd = "Sls " +localvault;
        p = Runtime.getRuntime().exec(cmd); 
        in2= new BufferedReader(new InputStreamReader(p.getInputStream()));
        line= null;
        int firstline=0;
        long startt =0, endt=0; float secs;

//         Vector inds = new Vector();
//         while ((line = in2.readLine()) != null){
//             if(firstline!=0){
//                 inds.addElement(line.trim());
//                 //System.out.println(line.trim());
//             }
//             firstline++;
//        }

//       String [] freeinds = new String[inds.size()];
//         //download from SRB and uncompress
//        for(int i =0; i < inds.size();i++){
//             String ind = (String)inds.elementAt(i);
//             cmd = "Sget "+localvault+ "/" +ind + " /home/nnakasho/indices/";
//             p = Runtime.getRuntime().exec(cmd); 
//             in2= new BufferedReader(new InputStreamReader(p.getErrorStream()));
//             while ((line = in2.readLine()) != null){
//                 System.out.println(line.trim());
//             }
//             String fl = unzip.unzip("/home/nnakasho/indices/"+ind);
//             freeinds[i] = fl;
//             //System.out.println(fl);
//        }
//        System.out.println("**** ***" +cmd);

       String [] freeinds = new File("/home/nnakasho/indices").list();
       System.out.println("len: "+freeinds.length);
       Directory [] thedirs = new Directory[freeinds.length-1];
       Directory theindexdir = null;
       //merge indices into one index.
       for(int i =0; i < freeinds.length;i++){
//             dir = freeinds[i];
//             name = dir.substring((dir.lastIndexOf('/')) +1, dir.length());
//             System.out.println("name: "+ name);
//             st = new StringTokenizer(name,"_");
//             st.nextToken(); //throw away the random number
//             dir = dir+"/"+st.nextToken()+"_"+st.nextToken();

            dir = "indices/"+freeinds[i];
            System.out.println("dir: "+dir);
            if(i==0)
                theindexdir= FSDirectory.getDirectory(new File(dir));
            else{
                thedirs[i-1] = FSDirectory.getDirectory(new File(dir));
            }
       }

       System.out.println("Merging ...");
       startt = new Date().getTime();
       IndexWriter writer2 = new IndexWriter(theindexdir, new StandardAnalyzer(), false);
       writer2.addIndexes(thedirs);
       writer2.close();
       endt = new Date().getTime();
       secs = (float)(endt-startt)/1000;
       System.out.println("Merging time: "+ secs);
       //remove unwanted inds
/*       for(int i =0; i< freeinds.length;i++){
            if(i==0){
                //File n = new File("/home/nnakasho/indices/"+(String)inds.elementAt(i));
                //n.delete();
            }
            else{
                //File n = new File("/home/nnakasho/indices/"+(String)inds.elementAt(i));
                //n.delete();
                deleteAllFiles(new File("indices/"+freeinds[i]));
            }
       }

       //ingest index into SRB
       cmd = "Sput -r indices/"+freeinds[0] +" _index_"+localvault;
       p = Runtime.getRuntime().exec(cmd); 
*/

    }

    public static boolean deleteAllFiles(File dir) { 
        if(!dir.exists()) 
            return true; 

        boolean res = true; 
        if(dir.isDirectory()) {
            File[] files = dir.listFiles();
            for(int i = 0; i < files.length; i++) 
                res &= deleteAllFiles(files[i]);
            res = dir.delete();//Delete dir itself
        } else 
            res = dir.delete(); 
        return res;
    }

    //upload the index to SRB

}