package queryjob.generator;

import java.io.*;
import java.util.Hashtable;
import java.lang.Math;
import java.util.Random;
import java.util.Vector;
import queryjob.ws.*;

import java.util.Date;
import java.util.Arrays;


/**
 * Class generates random queries based on a list of words
 * @author ndapandula nakashole 
 */ 

public class querygenerator{

    private Hashtable ht = new Hashtable();
    private Vector thewords = new Vector();
    private  int totalwords;
    private  String cfilename, words;
	 private  int answered=0, queries;
	 private  double interval;
	 
	  private class sendQuery implements Runnable{
			sendQuery(Query service,String q, String[] claims,int queryid) throws Exception{
			  // Web Services : Make a service
                        QueryService servicess = new QueryServiceLocator();
		        // Now use the service to get a stub to the service
		        Query queryservice = servicess.getquery();
		 
		        System.out.println("IN!: "+ queryid);  
                        System.out.println("thread "+Thread.currentThread().getName());
			System.out.println(queryservice.acceptQuery(q,claims,queryid));
			increment(1, queryid);
                        System.out.println("\tOUT!: "+ queryid);
			}
			public void run(){
			
			}
	  }

     public querygenerator(String words, int queries, double interval)throws Exception{
	  
	  	  this.words =words;
		  this.queries = queries;
		  this.interval = interval;
		  
        File  wfile= new File(words);
        if(wfile.exists() && wfile.canRead()){
            BufferedReader bf = new BufferedReader(new FileReader (wfile));
            String word; int j=0;
            word = bf.readLine();
            while(word != null){
               // System.out.println(word);
                ht.put(new Integer(j), word.toLowerCase());
                thewords.addElement(word);
                j++;
                word = bf.readLine();
            }
            totalwords = j;
        }
        else{
            System.out.println("File does not exist: " + words);
            System.exit(-1);
        }

        start();
	  }
    


    /** Starts the generator */
     void start() throws Exception{
        //System.out.println("\nGenerator Settings:\nwordsfile = "+words+"\nTo generate ["+ queries+"] queries every ["+ interval+"] hours\n");
        Random randy = new Random();

        int queryID = 0;//getRandom(randy, 5000);
        final String [] CODclaims = new String[1];
        String [] CODclaims2 = new String[1];


       // QueryService service = new QueryServiceLocator();
       // Query queryservice = service.getquery();
        String q =""; int server ;
	Vector times = new Vector();	
       QueryService servicess = new QueryServiceLocator();
       // Now use the service to get a stub to the service
       Query queryservice = servicess.getquery();  
        for(int i =0; i < queries; i++){
            q = "";
            //for(int j=0;j<4;j++)
            
         float totsecs = 0;
         final String qs = (String)thewords.elementAt(i);

         System.out.print(i+": ");
         float timet = 100000;
          for(int a = 0; a < 5; a++){
            // final String qs=(String)ht.get(new Integer(getRandom(randy, totalwords)));

/*                Thread sendq = new Thread (new Runnable() {
                    public void run() {
                        try{*/
                           // QueryService servicess = new QueryServiceLocator();
                             // Now use the service to get a stub to the service
                            //Query queryservice = servicess.getquery();  
                            final int queryid = getRandom(randy, 30000)+(queryID++);
 
                            //System.out.println("thread "+Thread.currentThread().getName());
                            long start = new Date().getTime();
                            String s = queryservice.acceptQuery(qs,CODclaims,queryid);  
                            long end = new Date().getTime();
                            //if(s.compareTo("nada") ==0)
                            //    System.out.println("Query nada: "+ qs);
                            //else
                            //System.out.print(".");
                            float ss = (float)(end -start);
                            if(ss < timet)
                           timet=ss;
                            //System.out.println("total time: "+(float) (end - start));
                            //increment(1, queryid);
                            //System.out.println("\tOUT!: "+ queryid);
                        /*}catch(Exception e){}
                    }
                }
                );
                sendq.start(); */            
            }
            if(timet>200) {
                 final int queryid = getRandom(randy, 30000)+(queryID++);
 
                            //System.out.println("thread "+Thread.currentThread().getName());
                            long start = new Date().getTime();
                            String s = queryservice.acceptQuery(qs,CODclaims,queryid);  
                            long end = new Date().getTime();
                            //if(s.compareTo("nada") ==0)
                            //    System.out.println("Query nada: "+ qs);
                            //else
                            //System.out.print(".");
                            float ss = (float)(end -start);
                            if(ss < timet)
                           timet=ss;
            }
             if(timet>200) {
                 final int queryid = getRandom(randy, 30000)+(queryID++);
 
                            //System.out.println("thread "+Thread.currentThread().getName());
                            long start = new Date().getTime();
                            String s = queryservice.acceptQuery(qs,CODclaims,queryid);  
                            long end = new Date().getTime();
                            //if(s.compareTo("nada") ==0)
                            //    System.out.println("Query nada: "+ qs);
                            //else
                            //System.out.print(".");
                            float ss = (float)(end -start);
                            if(ss < timet)
                           timet=ss;
            }
           // float tm = totsecs/(float)(5.0);
            times.addElement(new Float(timet));
        }
        System.out.println();
        float [] fls = new float [queries];
        
        for(int i =0; i < queries; i++){
            fls[i] = ((Float)(times.elementAt(i))).floatValue();;
            //(String)thewords.elementAt(i)
        }
        Arrays.sort(fls);
        int j=0;
       for(int i =(queries-1); i >=0; i--){
            System.out.println(j+ "\t"+fls[i]);
            j++;
        }
   
		  //increment(2, 0);
	  	  //end = new Date().getTime();
		 // System.out.println((float) (end - start) / 1000+": Time to repond to "+ queries+" queries");
    }



    /** Waits for the specified number of seconds 0.0006 ~= 2 seconds*/
   void waithours(double hours)throws Exception{
        int seconds = (int)(hours*3600.0);
        for(int i=0; i<seconds; i++){
            Thread.sleep(1000);
            System.out.print(".");
        }
        System.out.println();
    }

   /**
    * Returns a random number
    *
    * @param max The maximum number to be returned by this method
    */
    int getRandom(Random randy, int max){
        return Math.abs(randy.nextInt(max));
    }
	 
	 private synchronized void increment(int role, int queryid)throws Exception{ //this method is there to ensure that only when all the queries have been answered the program returns
		
		if(answered==queries)
			System.out.println("role: "+role+" :  ans"+ answered);
	   else if(role==1){
			answered++;
			if(answered==queries)
				notify();
		System.out.println("role: 1:  ans"+ answered + " Q:"+queryid);
	   }
		else if(role==2){
		System.out.println("role: 2:  ans"+ answered);
			wait();	
		}
		
		
    }
	 

    public static void main(String [] args) throws Exception{
       
		 String words2 = "";
		 int queries2 = 0;
		 double interval2=0;
		 if(args.length < 3){
            System.out.println("\nUsage: querygenerator wordsfile numqueries interval qfile\n\n\t\twordfile\tfile with list of words\n\t\tqueries\t\tnumber of queries generated at a time\n\t\tinterval\tthe time inteval between query batch generation (hours)");
            System.exit(-1);
        }

        try{
            words2 = args[0];
            queries2 = (new Integer(args[1])).intValue();
            interval2 = (new Double(args[2])).doubleValue();
           // cfilename = args[3];
        }
        catch(Exception e){
            System.out.println("Error parsing command line arguments");
            System.exit(-1);
        }
		  new querygenerator(words2,queries2,interval2);

    }
	 

}